// Decompiled by Jad v1.5.8e2. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://kpdus.tripod.com/jad.html
// Decompiler options: packimports(3) ansi 
// Source File Name:   MCH_WeaponGuidanceSystem.java

package mcheli.weapon;

import abw;
import aqz;
import asx;
import ata;
import atb;
import atc;
import atd;
import java.util.List;
import mcheli.MCH_Lib;
import mcheli.wrapper.W_Lib;
import mcheli.wrapper.W_WorldFunc;
import nn;

public class MCH_WeaponGuidanceSystem
{

    public MCH_WeaponGuidanceSystem(abw w)
    {
        worldObj = w;
        targetEntity = null;
        lastLockEntity = null;
        lockCount = 0;
        lockCountMax = 1;
        prevLockCount = 0;
        canLockInWater = false;
        canLockOnGround = false;
        canLockInAir = false;
        lockRange = 50D;
        lockAngle = 10;
    }

    public void setLockCountMax(int i)
    {
        lockCountMax = i <= 0 ? 1 : i;
    }

    public int getLockCountMax()
    {
        return lockCountMax;
    }

    public int getLockCount()
    {
        return lockCount;
    }

    public void update()
    {
        if(worldObj.I)
            if(lockCount != prevLockCount)
                prevLockCount = lockCount;
            else
                lockCount = prevLockCount = 0;
    }

    public static boolean isEntityOnGround(nn entity)
    {
        if(entity != null && !entity.M)
        {
            if(entity.F)
                return true;
            for(int i = 0; i < 3; i++)
            {
                int blockId = entity.q.a((int)(entity.u + 0.5D), (int)entity.v - i, (int)(entity.w + 0.5D));
                if(blockId != 0 && blockId != aqz.G.cF)
                    return true;
            }

        }
        return false;
    }

    protected boolean lock(nn user)
    {
        if(!worldObj.I)
            return false;
        boolean result = false;
        if(lockCount == 0)
        {
            List list = worldObj.b(user, user.E.b(lockRange, lockRange, lockRange));
            nn tgtEnt = null;
            double dist = lockRange * lockRange * 2D;
            for(int i = 0; i < list.size(); i++)
            {
                nn entity = (nn)list.get(i);
                if(!W_Lib.isEntityLivingBase(entity) || !canLockInWater && entity.H())
                    continue;
                boolean ong = isEntityOnGround(entity);
                if(!canLockOnGround && ong || !canLockInAir && !ong)
                    continue;
                double dx = entity.u - user.u;
                double dy = entity.v - user.v;
                double dz = entity.w - user.w;
                double d = dx * dx + dy * dy + dz * dz;
                if(d >= lockRange * lockRange || d >= dist || !inLockRange(user, entity, lockAngle))
                    continue;
                atc v1 = worldObj.V().a(user.u, user.v, user.w);
                atc v2 = worldObj.V().a(entity.u, entity.v, entity.w);
                ata m = W_WorldFunc.clip(worldObj, v1, v2);
                if(m == null || m.a == atb.b)
                {
                    d = dist;
                    tgtEnt = entity;
                }
            }

            targetEntity = tgtEnt;
            if(tgtEnt != null)
                lockCount++;
        } else
        if(targetEntity != null && !targetEntity.M)
        {
            boolean canLock = true;
            if(!canLockInWater && targetEntity.H())
                canLock = false;
            boolean ong = isEntityOnGround(targetEntity);
            if(!canLockOnGround && ong)
                canLock = false;
            if(!canLockInAir && !ong)
                canLock = false;
            if(canLock)
            {
                double dx = targetEntity.u - user.u;
                double dy = targetEntity.v - user.v;
                double dz = targetEntity.w - user.w;
                if(dx * dx + dy * dy + dz * dz < lockRange * lockRange)
                {
                    if(inLockRange(user, targetEntity, 10F))
                        lockCount++;
                    else
                        lockCount--;
                    if(lockCount >= lockCountMax)
                    {
                        result = true;
                        lastLockEntity = targetEntity;
                        lockCount = 0;
                        targetEntity = null;
                    }
                } else
                {
                    targetEntity = null;
                    lockCount = 0;
                }
            } else
            {
                targetEntity = null;
                lockCount = 0;
            }
        } else
        {
            targetEntity = null;
            lockCount = 0;
        }
        return result;
    }

    public static boolean inLockRange(nn entity, nn target, float lockAng)
    {
        double dx = target.u - entity.u;
        double dy = target.v - entity.v;
        double dz = target.w - entity.w;
        float entityYaw = (float)MCH_Lib.getRotate360(entity.A);
        float targetYaw = (float)MCH_Lib.getRotate360((Math.atan2(dz, dx) * 180D) / 3.1415926535897931D);
        float diffYaw = (float)MCH_Lib.getRotate360(targetYaw - entityYaw - 90F);
        float entityPitch = -entity.B;
        float targetPitch = (float)((Math.atan2(dy * dy, dx * dx + dz * dz) * 180D) / 3.1415926535897931D);
        if(dy < 0.0D)
            targetPitch = -targetPitch;
        else
            targetPitch += 15F;
        float diffPitch = (float)MCH_Lib.getRotate360(targetPitch - entityPitch);
        return (diffYaw < lockAng || diffYaw > 360F - lockAng) && (diffPitch < lockAng || diffPitch > 360F - lockAng);
    }

    protected abw worldObj;
    public nn lastLockEntity;
    private nn targetEntity;
    private int lockCount;
    private int lockCountMax;
    private int prevLockCount;
    public boolean canLockInWater;
    public boolean canLockOnGround;
    public boolean canLockInAir;
    public double lockRange;
    public int lockAngle;
}
